module bwi_struct_mod
  use  base_struct_mod
  implicit none

  type bwi_ftag
    character(len=256) :: csou_             !!.. source wavefield
    character(len=256) :: crec_             !!.. receiver wavefield
    character(len=256) :: bvel_             !!.. background velocity
    character(len=256) :: beta_             !!.. background eta
    character(len=256) :: bdel_             !!.. background delta
    character(len=256) :: bimg_             !!.. background image
    character(len=256) :: dvel_             !!.. perturbed velocity
    character(len=256) :: deta_             !!.. perturbed eta 
    character(len=256) :: dimg_             !!.. perturbed image 
    character(len=256) :: bwfs_
    character(len=256) :: bwfr_
    character(len=256) :: dwfs_
    character(len=256) :: dwfr_
    character(len=256) :: srch_
    character(len=256) :: grdo_
    character(len=256) :: grdp_
    character(len=256) :: gsou_
    character(len=256) :: grec_
    character(len=256) :: sfnc_
    character(len=256) :: hess_
    character(len=256) :: imsk_
    character(len=256) :: gmsk_
    character(len=256) :: hsou_
    character(len=256) :: coef_				!!.. optimized coefficients
    character(len=256) :: dcef_				!!.. derivative optimized coefficients
  end type

end module

